#include "extrafunctions.h"
#include "converter.h"


//--------------------------------------------------------------------------------------
void printGrid(int **theGrid, int sqLen, int grLen)
{
	//PRINTS THE GRID TO THE SCREEN
	int r,c;
	
	for(r=0; r<grLen; r++){
		cout<<'\n';
		for(c=0; c<grLen; c++){
			if(theGrid[r][c]==0)cout<<"[-]\t";
			else cout<<"["<<theGrid[r][c]<<"]\t";
		}
	}
	cout<<"\n\n";
}

//--------------------------------------------------------------------------------------
bool gridOK(int **theGrid, int sqLen, int grLen)
{
	//A SIMPLE FUNCTION TO CHECK THAT THE INPUT GRID IS VALID
	int r, c, j, count, r1, c1;
	bool valid = true;
	int first = 1;

	//First, we want to check that the grid has been read in correctly
	for(r=0;r<grLen;r++){
		for(c=0;c<grLen;c++){
			if(theGrid[r][c]<0 || theGrid[r][c] > first+grLen){
				cout<<"Error: Cell ["<<r<<", "<<c<<"] contains an out-of-range entry\n";
				valid = false;
			}
		}
	}
	
	if(valid){
		//Go through each row and check for duplicates
		for(r=0;r<grLen;r++){
			j=first;
			while(j<first+grLen){
				count=0;
				for(c=0;c<grLen;c++) if(theGrid[r][c]==j) count++;
				if(count>1){
					cout<<"Error. There are "<<count<<" occurences of "<<j<<" on row "<<r<<endl;
					valid = false;
				}
				j++;
			}
		}
		
		//Then columns
		for(c=0;c<grLen;c++){
			j=first;
			while(j<first+grLen){
				count=0;
				for(r=0;r<grLen;r++) if(theGrid[r][c]==j) count++;
				if(count>1){
					cout<<"Error. There are "<<count<<" occurences of "<<j<<" in column "<<c<<endl;
					valid = false;
				}
				j++;
			}
		}

		//Then Boxes
		for(r=0;r<sqLen;r++){
			for(c=0;c<sqLen;c++){
				j=first;
				while(j<first+grLen){
					count=0;
					//This goes through box r c
					for(r1=r*sqLen; r1<(r+1)*sqLen;r1++){
						for(c1=c*sqLen; c1<(c+1)*sqLen;c1++){
							if(theGrid[r1][c1]==j) count++;
						}
					}
					if(count>1){
						cout<<"Error. There are "<<count<<" occurences of "<<j<<" in square ["<<r<<","<<c<<"]\n";
						valid = false;
					}
					j++;
				}
			}
		}
	}
	
	if(!valid)	cout<<"Grid is not valid"<<endl;
	return(valid);
}



